program makehelp;

{
  builds the help into foreach.exe

  run as part of make
}

const
  exeFN = 'foreach.exe';
  txtFN = 'foreach.txt';
  id    = 'tman';

type
  string4T = array[1..4] of char;

procedure quit (message : string);
begin
  if message <> '' then writeln (message);
  halt;
end;

var
  exeF : file;
  txtF : text;
  size : longInt;
  numRead : integer;
  s : string[79];
  found : boolean;
  ch : char;
  b : byte;

begin

  writeln ('makehelp : ');

  assign (exeF, exeFN);
  {$I-}
  reset (exeF, 1);
  {$I+}
  if ioResult <> 0 then quit ('unable to open ' + exeFN);

  assign (txtF, txtFN);
  {$I-}
  reset (txtF);
  {$I+}
  if ioResult <> 0 then quit ('unable to open ' + txtFN);

  { replace special with exe size }
  size := fileSize (exeF);
  writeln ('  exe size = ', size, ' bytes');
  writeln ('  looking for "', id, '" in ', exeFN);
  found := false;
  repeat
    blockRead (exeF, ch, 1, numRead);
    if (numRead <> 0) and (ch = 't') then
      begin
        s := id;
        for b := 2 to length (s) do
          s[b] := '-';
        blockread (exeF, s[2], 3);
        found := s = id;
      end;
  until (numRead = 0) or (found);
  if (numRead = 0) or (not found) then quit ('couldn''t find "' + id + '" in ' + exeFN);
  seek (exeF, filePos (exeF) - 4);
  writeln ('  found "', id, '" at ', filePos (exeF));
  inc (size);
  blockwrite (exeF, size, 4);
  writeln ('  wrote new size');

  { append help text }
  writeln ('  appending help text');
  seek (exeF, fileSize (exeF) + 1);
  while not eof (txtF) do
    begin
      fillChar (s, sizeOf (s), 255);
      readln (txtF, s);
      blockwrite (exeF, s, sizeOf (s));
    end;

  close (txtF);
  close (exeF);

  writeln ('done');

end.
